﻿using Common;
using Newtonsoft.Json.Linq;
using RedisHelp;
using System;
using System.Collections.Generic;
using System.Drawing;
using System.Drawing.Imaging;
using System.IO;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Text;
using System.Web;
using System.Web.Http;
using TGood.Xian.LogManager;
using ThoughtWorks.QRCode.Codec;
using WxPayAPI.Models;
using wxWebAPI.Filters;
using wxWebAPI.Models;

namespace WxPayAPI
{
    [OptionsFilter]
    public partial class FinanceController : ApiController
    {
        #region 充值记录

        [HttpGet, HttpOptions]
        public JObject GetRechargeRecord(string id, DateTime? start = null, DateTime? end = null, int recordMin = 0, int recordMax = int.MaxValue)
        {
            JObject result = new JObject();
            try
            {
                var finance = new Finance();
                var checkResult = finance.GetRechargeRecord(id, start, end, recordMin, recordMax);
                result.Add("code", 1);
                result.Add("data", JProperty.FromObject(checkResult));
            }
            catch (Exception ex)
            {
                string errorPara = $"FinanceController - GetCardRechargeRecord Error, id={id}, start={start}, end ={end}, " +
                                $"recordMin={recordMin}, recordMax={recordMax}";
                LogEvent.WebAPILoger.Error(errorPara, ex);
                result.RemoveAll();
                result.Add("code", 0);
                result.Add("error", ex.ToString());
            }
            return result;
        }

        [HttpGet, HttpOptions]
        public JObject GetCardRechargeRecord(string id, DateTime? start = null, DateTime? end = null, 
            int recordMin = 0, int recordMax = int.MaxValue, string orderby = RechargeRecord.columnRecordtime, bool desc = true)
        {
            JObject result = new JObject();
            try
            {
                var finance = new Finance();
                var checkResult = finance.GetCardRechargeRecord(id, start, end, recordMin, recordMax, orderby, desc);
                result.Add("code", 1);
                result.Add("data", JProperty.FromObject(checkResult));
            }
            catch (Exception ex)
            {
                string errorPara = $"FinanceController - GetCardRechargeRecord Error, id={id}, start={start}, end ={end}, " +
                                $"recordMin={recordMin}, recordMax={recordMax}, orderby={orderby}, desc={desc}";
                LogEvent.WebAPILoger.Error(errorPara, ex);
                result.RemoveAll();
                result.Add("code", 0);
                result.Add("error", ex.ToString());
            }
            return result;
        }

        #endregion
    }
}
